require "config"

-- Mandatory Stuff!
require("prototypes.intermediates.circuits-item")
require("prototypes.intermediates.circuits-recipe")
require("prototypes.intermediates.circuits-tech")
require("prototypes.intermediates.gears-item")
require("prototypes.intermediates.gears-recipe")
require("prototypes.intermediates.machines-item")
require("prototypes.intermediates.machines-recipe")
require("prototypes.intermediates.machines-tech")
require("prototypes.intermediates.plates-item")
require("prototypes.intermediates.plates-tech")
require("prototypes.intermediates.power-item")
require("prototypes.intermediates.power-recipe")
require("prototypes.intermediates.power-tech")
require("prototypes.intermediates.resources-item")
require("prototypes.intermediates.resources-recipe")
require("prototypes.intermediates.smelting-recipe")
require("prototypes.intermediates.tank-item")
require("prototypes.intermediates.tank-recipe")
require("prototypes.intermediates.tank-tech")
require("prototypes.machines.centrifuge.entity")
require("prototypes.machines.centrifuge.item")
require("prototypes.machines.centrifuge.recipe")
require("prototypes.machines.centrifuge.tech")
require("prototypes.machines.compressor.entity")
require("prototypes.machines.compressor.item")
require("prototypes.machines.compressor.recipe")
require("prototypes.machines.compressor.tech")
require("prototypes.machines.liquid-handler.entity")
require("prototypes.machines.liquid-handler.item")
require("prototypes.machines.liquid-handler.recipe")
require("prototypes.machines.liquid-handler.tech")
require("prototypes.recipes.coal")
require("prototypes.recipes.crystals")
require("prototypes.resources.gems-item")
require("prototypes.resources.gems-recipe")
require("prototypes.resources.gems-resource")
require("prototypes.resources.metallurgic-ore-ardite")
require("prototypes.resources.metallurgic-ore-cobalt")
require("prototypes.resources.metallurgic-ore-gold")
require("prototypes.resources.metallurgic-ore-items")
require("prototypes.resources.metallurgic-ore-lead")
require("prototypes.resources.metallurgic-ore-silver")
require("prototypes.resources.metallurgic-ore-tin")
require("prototypes.resources.metallurgic-ore-tungsten")
require("prototypes.resources.metallurgic-ore-zinc")
require("prototypes.resources.water-fluid")
require("prototypes.resources.water-recipe")
require("prototypes.trees.rubber-tree-entity")
require("prototypes.trees.rubber-tree-item")
require("prototypes.trees.rubber-tree-recipe")
require("prototypes.trees.seed-recipe")
require("prototypes.trees.sulfur-tree-entity")
require("prototypes.trees.sulfur-tree-item")
require("prototypes.trees.sulfur-tree-recipe")

-- Items Groups
require("prototypes.item-group.dytech-combat")
require("prototypes.item-group.dytech-energy")
require("prototypes.item-group.dytech-gem")
require("prototypes.item-group.dytech-inserter")
require("prototypes.item-group.dytech-intermediates")
require("prototypes.item-group.dytech-machines")
require("prototypes.item-group.dytech-modules")
require("prototypes.item-group.dytech-nuclear")
require("prototypes.item-group.metallurgy-1")
--require("prototypes.item-group.metallurgy-2")
--require("prototypes.item-group.metallurgy-3")
require("prototypes.item-group.invisible")

-- Noise Layers
require("prototypes.tile.noise-layers")

-- Catergories
require("prototypes.categories.ammo-category")
require("prototypes.categories.recipe-category")
require("prototypes.categories.resource-category")
require("prototypes.damage-type")

-- Autoplace Control
require("prototypes.autoplace-controls")

if BaseOverride then
require("prototypes.base-override")
end

if Technologies then
require("prototypes.researches.player")
require("prototypes.researches.bots")
require("prototypes.researches.misc")
end

for k, v in pairs(data.raw.module) do
	if v.name:find("productivity%-module") and v.limitation then
		table.insert(v.limitation, "advanced-processing-unit")
		table.insert(v.limitation, "bundled-wire")
		table.insert(v.limitation, "rubber")
		table.insert(v.limitation, "stone-gear-wheel")
		table.insert(v.limitation, "steel-gear-wheel")
		table.insert(v.limitation, "tin-gear-wheel")
		table.insert(v.limitation, "zinc-gear-wheel")
		table.insert(v.limitation, "lead-gear-wheel")
		table.insert(v.limitation, "cobalt-gear-wheel")
		table.insert(v.limitation, "tungsten-gear-wheel")
		table.insert(v.limitation, "frame-1")
		table.insert(v.limitation, "frame-2")
		table.insert(v.limitation, "frame-3")
		table.insert(v.limitation, "frame-4")
		table.insert(v.limitation, "item-exit-1")
		table.insert(v.limitation, "item-exit-2")
		table.insert(v.limitation, "item-exit-3")
		table.insert(v.limitation, "item-exit-4")
		table.insert(v.limitation, "rotor-1")
		table.insert(v.limitation, "rotor-2")
		table.insert(v.limitation, "rotor-3")
		table.insert(v.limitation, "rotor-4")
		table.insert(v.limitation, "blade-1")
		table.insert(v.limitation, "blade-2")
		table.insert(v.limitation, "blade-3")
		table.insert(v.limitation, "capacitor-1")
		table.insert(v.limitation, "capacitor-2")
		table.insert(v.limitation, "capacitor-3")
		table.insert(v.limitation, "capacitor-4")
		table.insert(v.limitation, "flux-capacitor-1")
		table.insert(v.limitation, "flux-capacitor-2")
		table.insert(v.limitation, "flux-capacitor-3")
		table.insert(v.limitation, "flux-capacitor-4")
		table.insert(v.limitation, "sandbag")
		table.insert(v.limitation, "glass")
		table.insert(v.limitation, "bone-charcoal")
		--[[table.insert(v.limitation, "ruby-2")
		table.insert(v.limitation, "ruby-3")
		table.insert(v.limitation, "ruby-4")
		table.insert(v.limitation, "ruby-5")
		table.insert(v.limitation, "emerald-2")
		table.insert(v.limitation, "emerald-3")
		table.insert(v.limitation, "emerald-4")
		table.insert(v.limitation, "emerald-5")
		table.insert(v.limitation, "sapphire-2")
		table.insert(v.limitation, "sapphire-3")
		table.insert(v.limitation, "sapphire-4")
		table.insert(v.limitation, "sapphire-5")
		table.insert(v.limitation, "diamond-2")
		table.insert(v.limitation, "diamond-3")
		table.insert(v.limitation, "diamond-4")
		table.insert(v.limitation, "diamond-5")
		table.insert(v.limitation, "topaz-2")
		table.insert(v.limitation, "topaz-3")
		table.insert(v.limitation, "topaz-4")
		table.insert(v.limitation, "topaz-5")]]--
	end
end